############Functions needed for the complex normal distribution working in the preform space!!!!!

st=function (zstar) 
{
    st <- t(Conj(zstar))
    st
}

##
defh=function (nrow) 
{
    k <- nrow
    h <- matrix(0, k, k + 1)
    j <- 1
    while (j <= k) {
        jj <- 1
        while (jj <= j) {
            h[j, jj] <- -1/sqrt(j * (j + 1))
            jj <- jj + 1
        }
        h[j, j + 1] <- j/sqrt(j * (j + 1))
        j <- j + 1
    }
    h
}


################
hyperg<-function(k,al)
#confluent hypergeometric function 1.1. calculated at k(negative integer) and al positive value, i.e it is 1F1(k,1,-al)
{
S<-0
for (i in 0:(-k))
S<-S+choose(-k, i)*al^i/gamma(1+i)
S
}
#######################
ratio.constant.alt<-function(k,al)
{
Y<--k/al*(hyperg(k,al^2)/hyperg(1+k,al^2)-1)
Y
}
#####
inv<-function(C)
{
S<-La.svd(C)
y<-S$u%*%diag(1/S$d)%*%(S$v)
y
}
#gen.riemdist(preshape(x),preshape(y))
########

#######
gen.prod<-function(x,y,C=diag(rep(1,length(x))))
{
Y<-st(x)%*% inv(C)%*%y
Y
}
##############
###
gen.riemdist<-function(x,y,C=diag(rep(1,length(x))))
{
x0<-x/sqrt(Mod(gen.prod(x,x,C)))
y0<-y/sqrt(Mod(gen.prod(y,y,C)))

riem<-c(acos(min(1,(Mod(st(x0) %*% inv(C)%*%y0)))))
riem
}
####

rotate.fit<-function(x,y,C=diag(rep(1,length(x))))
{
alpha<-Arg(st(x) %*% inv(C)%*%y)
x0<-complex(modulus = 1, argument= alpha)*x
x0
}
##################
var.complex<-function(x)
{
A<-scale(x, center = TRUE, scale = FALSE)
V<-st(A)%*%A/dim(x)[1]
V
}
#############

######################

iterat.complex.isot.alt<-function(D,M,C=diag(rep(1,length(M))))
{
n<-dim(D)[2]
k<-dim(D)[1]
D1<-D
#C1<-diag(rep(1,length(M)))
C1<-C
C0<-array(0,c(k,k))
#a<-centroid.size(M)
for (i in 1:n)
{
D[,i]<-rotate.fit(D[,i],M,C1)
a<-Mod(gen.prod(D[,i],D[,i],C1))
b<-Mod(gen.prod(D[,i],M,C1))
alpha<-b/sqrt(a)
D1[,i]<-D[,i]*ratio.constant.alt(-k,alpha)/sqrt(a)
}

#cat(riemdist(M,M0),"\n")
M1<-apply(D1,c(1),mean)
l<-log.likelih.compl.alt(D,M1,C1)
#cat(l,"\n")
Y<-list();
Y$D<-D; Y$M<-M1; 
Y$C<-(C1);
Y$llik<-l
Y
}
 #K<-EM.fit.complex(D1[,1:20],M01,tol=1e-05,niter=2000,type=2); norm(K$M)

#######################
iterat.complex.alt<-function(D,M,C=diag(rep(1,length(M))))
{
n<-dim(D)[2]
k<-dim(D)[1]
#D2<-D
D1<-D
C0<-array(0,c(k,k))
C01<-array(0,c(k,k))
#a<-centroid.size(M)
for (i in 1:n)
{
D[,i]<-rotate.fit(D[,i],M,C)
a<-Mod(gen.prod(D[,i],D[,i],C))
b<-Mod(gen.prod(D[,i],M,C))
alpha<-b/sqrt(a)
D1[,i]<-D[,i]*ratio.constant.alt(-k,alpha)/sqrt(a)
#beta<-(1/a-sqrt(a)/b)*hyperg(-k,b^2/2/a)/hyperg(1-k,b^2/2/a)-sqrt(a)/b
beta<-k/a*(-1)*hyperg(-k,alpha^2)/hyperg(1-k,alpha^2)-ratio.constant.alt(-k,alpha)^2/a
#C01<-C0+beta[1,1]*D[,i]%*%st(D[,i])
beta1<-1*k/a*hyperg(-k,alpha^2)/hyperg(1-k,alpha^2)
#C0<-C0+beta1[1,1]*D[,i]%*%st(D[,i])-D1[,i]%*%st(D1[,i])
C01<-C01+beta1[1,1]*(D[,i])%*%st(D[,i])
}

#cat(riemdist(M,M0),"\n")
M1<-apply(D1,c(1),mean)
#C1<- var.complex(t(D1))+(1-1/n)/n*Conj(C0)
C1<- 1/n*(C01)-(M1)%*%st(M1)
#cat(gen.riemdist(M1,M),"  ", norm.c(M1),"\n")
#C1<-Conj(C1)
l<-log.likelih.compl.alt(D,M1,C1)
#cat(l,"\n")
Y<-list();
Y$D<-D; Y$M<-M1/(M1[1]); 
Y$C<-1*(C1)/norm.c(M1[1])^2;
#Y$D<-D; Y$M<-M1; 
#Y$C<-1*(C1);
Y$llik<-l
Y
} 
#K<-EM.fit.complex.alt(D1[,1:5],M01,tol=1e-05,niter=20,type=1)
#K1<-EM.fit.complex.alt(D1[,1:5],apply(D1,1,mean),var.complex(st(D1)),tol=1e-03,niter=20,type=1)
 #K<-EM.fit.complex.alt(D1[,1:10],M01*100,tol=1e-05,niter=20,type=1)
#l<-iterat.complex.alt(D1,M1,C); l<-iterat.complex(l$D,l$M,l$C)
#l1.14<-EM.fit.complex.alt(sch.co.kend[,1:14],l2.14$M,l1.14$C,type=1,niter=3500,tol=1e-7);cat("\a")
#iterat.complex(D,M1,C1)
########
EM.fit.complex.alt<-function(D,M,C=diag(rep(1,length(M))),tol=1e-06,niter=200,type=1)
#runs the EM for the complex covariance matrix. 
#if type=1 full-covariance, else the isotropic covariance 
#the original data are in the pre-shape space
#the output is the transformed data, the mean, the covariance and the log-likelihooh value
{
i<-1
Morig<-M
Corig<-C

#M0<-iterat.complex.isot(D,M)
if (type==1)
{
firststep<-iterat.complex.alt(D,M,C)
iterationfunction<-iterat.complex.alt
}
else
{
iterationfunction<-iterat.complex.isot.alt
#M<-M0
#C<-diag(rep(1,length(M)))
firststep<-iterat.complex.isot.alt(D,M,C)
}

D<-firststep$D
M<-firststep$M
C<-firststep$C
#l1<-log.likelih.compl(firststep$D,firststep$M,firststep$C)
l1<-0
l2<-log.likelih.compl.alt(D,M,C)
w<-rotate.fit(M,Morig)[1]/M[1]

#while ((norm.c(Morig-rotate.fit(M,Morig))+norm.c(Corig-C))>tol& i<niter )
#while (  abs(l1-log.likelih.compl.alt(D,M,C))>tol& i<niter)
while (max(c(max(abs(Morig-w*M)),max(abs(Corig-w*C*Conj(w))))) >tol& i<niter)
#while (abs(l1-log.likelih.compl.alt(D,M,C))/(norm.c(Morig-w*M)+norm.c(Corig-w*C*Conj(w)))>tol& i<niter)
{
#cat(norm.c(Morig-rotate.fit(M,Morig)), "  " ,norm.c(Corig-C),"\n")
w<-rotate.fit(M,Morig)[1]/M[1]
#cat("grad=",abs(l1-log.likelih.compl.alt(D,M,C))/(norm.c(Morig-w*M)+norm.c(Corig-w*C*Conj(w))),abs(l1-log.likelih.compl.alt(D,M,C)),(norm.c(Morig-w*M)+norm.c(Corig-w*C*Conj(w))),"\n")
#l2<-log.likelih.compl.alt(D,M,C)
cat("grad=",abs(l1-l2)/(norm.c(Morig-w*M)+norm.c(Corig-w*C*Conj(w))),l2-l1,c(max(abs(Morig-w*M)),max(abs(Corig-w*C*Conj(w)))),i,"\n")

Morig<-M
Corig<-C
#l1<-log.likelih.compl.alt(firststep$D,firststep$M,firststep$C)
l1<-l2
firststep<-iterationfunction(D,M,C)
l2<-firststep$llik
cat("llik=",l1,firststep$llik,"\n")

D<-firststep$D
M<-firststep$M
C<-firststep$C
i<-i+1
}
cat(i,"\n")
rm(iterationfunction)
firststep
}
#K<-EM.fit.complex.alt(D1[,1:10],M01*50,tol=1e-05,niter=2,type=2)
#EM.fit.complex(K$D,K$M,K$C,tol=1e-05,niter=2,type=2)
#K1<-EM.fit.complex.alt(D1[,1:5],apply(D1,1,mean),var.complex(st(D1)),tol=1e-03,niter=20,type=1)
######################################
####################
log.likelih.compl.alt<-function(D,M,C=diag(rep(1,length(M))))
#this is the exact log-likhd
{
kappa.C.sq<-Mod(gen.prod(M,M,C))
S<-0
p<-dim(D)[1]-1
for (i in 1:dim(D)[2])
{
a<-Mod(gen.prod(D[,i],D[,i],C))
b<-Mod(gen.prod(D[,i],M,C))
#rho<-gen.riemdist(D[,i]/gen.prod(D[,i],D[,i],C),M/gen.prod(M,M,C))
#rho<-riemdist(D[,,i],M)
#S<-S+log(hyperg(1-dim(D)[1],b^2/2/a))+(-kappa.C.sq/2+b^2/2/a)-dim(D)[1]*log(a)
#-log(det(C))
S<-S+log(hyperg(1-dim(D)[1],b^2/a))+(-kappa.C.sq+b^2/a)-dim(D)[1]*log(a)
#+dim(D)[1]*log(Mod(gen.prod(D[,i],D[,i])))
}
S<-S+dim(D)[2]*(log(gamma(p+1))-p*log(pi)-log(prod(La.svd(C)$d)))
S
}#log.likelih.compl.alt(D,M,C)

likelih<-function(D,M)
{
kappa<-centroid.size(M)^2/4
S<-1
for (i in 1:dim(D)[3])
{
rho<-riemdist(D[,,i],M)
S<-S*hyperg(2-dim(D)[1],kappa*(1+cos(2*rho)))*exp(-kappa*(1-cos(2*rho)))
}
S
}

#likelih(res$D,res$M)

iterat<-function(D,M)
{
n<-dim(D)[3]
k<-dim(D)[1]
D1<-D
a<-centroid.size(M)
for (i in 1 :n)
{
D[,,i]<-D[,,i]%*%fort(M,D[,,i])
#al<-a*cos(riemdist(M,D[,,i]))
#al<-sum(diag(t(M)%*%D[,,i]%*%fort(M,D[,,i])))
al<-sum(diag(t(M)%*%D[,,i]))
D1[,,i]<-D[,,i]*ratio_constant(1-k,al)
}
cat(riemdist(M,M0),"\n")
M1<-apply(D1,c(1,2),mean)
cat(riemdist(M1,M0),norm(M1),"\n")
#cat(likelih(res$D,res$M),"\n")
Y<-list();
Y$D<-D; Y$M<-M1
Y
}

EM.fit<-function(D,M,tol=1e-05,niter=200)
{
i<-1
Morig<-M
firststep<-iterat(D,M)
D<-firststep$D
M<-firststep$M

while (norm(Morig-M%*%fort(Morig,M))>tol& i<niter)
{
Morig<-M
firststep<-iterat(D,M)
D<-firststep$D
M<-firststep$M
i<-i+1
}
cat(i,"\n")
firststep
}


conc.param.mle<-function(M,D)
{
n<-dim(D)[3]
k<-dim(D)[1]
opt.funct<-function(S)
{
D1<-D
M0<-S*(M)
Y<-0
for (i in 1 :n)
{
#D[,,i]<-D[,,i]%*%fort(M,D[,,i])
#al<-a*cos(riemdist(M,D[,,i]))
#al<-sum(diag(t(M)%*%D[,,i]%*%fort(M,D[,,i])))
#al<-sum(diag(t(M0)%*%D[,,i]))
al<-cos(riemdist(D[,,i],M))*S
Y<-Y+cos(riemdist(D[,,i],M))*ratio_constant(1-k,al)
}
Y<-S-Y
Y
}
Z<-uniroot(opt.funct,lower=-1,upper=1)
Z
}
 #conc.param.mle(proc1,D)
###############
norm.c<-function (a) 
{
    return(Mod(sqrt(sum(diag(st(a) %*% a)))))
}
###
realtocomplex.matrix<-function(D)
{
if (length(dim(D))==2)
D1<-realtocomplex(D)
else
{
D1<-array(0,c(dim(D)[1],dim(D)[3]))
for (i in 1:dim(D)[3])
{
T<-(D[,,i])
D1[,i]<-T[,1]+T[,2]*1i
}
}
D1
}
##########
complextoreal.matrix<-function(D)
{
if (is.vector(D)==TRUE)
D1<-complextoreal(D)
else
{
D1<-array(0,c(dim(D)[1],2,dim(D)[2]))
for (i in 1:dim(D)[2])
{
T<-(D[,i])
D1[,1,i]<-Re(T)
D1[,2,i]<-Im(T)
}
}
D1
}
###
realtocomplex.matrix.ken<-function(D)
{
if (length(dim(D))==2)
D1<-realtocomplex(D)
else
L<-diag(rep(1,dim(D)[1]))
L[,1]<--1
L<-L[-1,]
{
D1<-array(0,c(dim(D)[1]-1,dim(D)[3]))
for (i in 1:dim(D)[3])
{
T<-L%*%(D[,,i])
D1[,i]<-T[,1]+T[,2]*1i
D1[,i]<-D1[,i]/D1[1,i]
}
}
D1
}
##########
EM.regression.fit<-function(D,T,A,tol=1e-5,niter=200)
#D data in a complex matrix of dimension kxnxm where k-landmarks, n-knots and m-paths
#the original data are in the configuration space
# T- is the vector of time observations of dimension n
{
lik.regres<-function(D,A,T)
{
l<-0
for (i in 1:dim(D)[2])
l<-l+log.likelih.compl.alt(D[,i,],A%*%c(1,T[i]))
l
}

l<-1
d<-dim(D);d[1]<-d[1]-1
D0<-array(0,d)
for(i in 1:d[3])
D0[,,i]<-defh(d[1])%*%D[,,i]
TM<-cbind(1,T)
B1<-inv(t(TM)%*%TM)
Aorig<-A
A0<-array(0,c(d[1],2))
for (i in 1:d[2])
A0<-A0+iterat.complex.isot.alt(D0[,i,], Aorig%*%c(1,T[i]) )$M%*%t(c(1,T[i]))
A<-A0%*%B1
LL<-0;LL0<--1; LLD0<-0
while(norm.c(A-Aorig)>tol & l<niter)
{
Aorig<-A
A<-array(0,c(d[1],2))

for (i in 1:d[2])
{
IT<-iterat.complex.isot.alt( D0[,i,], Aorig%*%c(1,T[i]) )
A<-A+IT$M%*%t(c(1,T[i]))
LL<-LL+IT$llik
}
A<-A%*%B1
l<-l+1
LLD<-lik.regres(D0,A,T)
cat("l=",norm.c(A-Aorig),l,LL,LL-LL0,LLD,LLD-LLD0, "\n")
LLD0<-lik.regres(D0,A,T)
LL0<-LL
LL<-0
}
A
}
#EM.regression.fit(D,T,A,niter=50)
#a<-EM.regression.fit(D,T,a,niter=300)

